--------------------------------------------------------------------------------
--                                  i_rfind.e                                 --
--                       Written by Lucius L. Hilley III                      --
--                                May 12, 2002                                --
--------------------------------------------------------------------------------

neg_indx = 0
indx_fix = 0

global procedure negative_indexing(integer i)
  neg_indx = i
end procedure

global procedure neg_indexing(integer i)
  neg_indx = i
end procedure

global procedure index_fix(integer i)
  indx_fix = i
end procedure

global procedure index_fixing(integer i)
  indx_fix = i
end procedure

global function fix_index(object index, integer max)
  object index2, imask

  if neg_indx then
    imask = (0 > index)
    index2 = imask + (max + 1)
  else
    index2 = index
  end if

  if indx_fix then
    imask = (1 > index2)
    index2 = ((imask = 0) * index2) + imask

    imask = (index2 > max)
    index2 = ((imask = 0) * index2) + (imask * max)
  end if

  return index2
end function

global function i_find(object x, sequence s, atom index)
  integer f, index2, ls

  f = find(x, s[index2..ls])
  if (f) then
    return f + index2 - 1
  else
    return 0
  end if
end function

global function rfind(object x, sequence s)

  for A = length(s) to 1 by -1 do
    if compare(x, s[A]) = 0 then
      return A
    end if
  end for

  return 0
end function

global function i_rfind(object x, sequence s, atom index)
  integer f, index2, ls

  ls = length(s)
  if neg_indx then
    if (0 > index) then
      index2 = ls + 1 + index
    end if
  end if

  if indx_fix then
    if (index = 0) then
      index = 1
    elsif (index > ls) then
      index2 = ls
    else
      index2 = index
    end if
  end if

  f = rfind(x, s[1..index2])
  if (f) then
    return f + index2 - 1
  else
    return 0
  end if
end function

